{----------------------------------------------------------------------------
  Subroutine RKF45 by H.A.WATTS, L.F.SHAMPINE , NEW Mexico
      Adupted by S.Kvashnin, MHTS, January 1988
----------------------------------------------------------------------------}
 program rkf45test;
 uses Crt,RKF45U,Kernel;
 const n=4;
 label 10,stop;
 type mass_n=array[1..n] of RealType;
 var
   ecc,t,alfa,alfasq,relerr,abserr,tfinal,tprint,tout,h,savre,savae :realType;
   iflag,nfe,kop,init,jflag,kflag                                   : integer;
   y,ypp,f1,f2,f3,f4,f5                                              : mass_n;


  function amax(x1,x2: RealType): RealType;
     begin if x1>x2 then amax:=x1 else amax:=x2 end;

  function amin(x1,x2: RealType): RealType;
     begin if x1<x2 then amin:=x1 else amin:=x2 end;

  function isign(x1,x2 : integer): integer;
    begin
      if x2=0 then isign:=0
         else
             isign:=x2 div abs(x2)*abs(x1);
     end;

  function sign(x1,x2 : RealType): RealType;
    begin
      if x2=0 then sign:=0
         else
             sign:=x2/abs(x2)*abs(x1);
     end;

  procedure FexRunge(t: realType; var y1; n: integer; var yp1);
  var
    r       : realType;
    w         : RealTypeArray absolute Y1;
    yp         : RealTypeArray absolute Yp1;
   begin
     { test ORBIT }
     r:=w[1]*w[1]+w[2]*w[2];
     r:=r*sqrt(r)/alfasq;
     yp[1]:=w[3];
     yp[2]:=w[4];
     yp[3]:=-w[1]/r;
     yp[4]:=-w[2]/r;
   end;
{---------------------------------------------------------------------------}
{ I RKF45.PAS}
{---------------------------------------------------------------------------}

begin
     alfa:=pi*0.25;
     alfasq:=alfa*alfa;


 ecc:=0.25;
 t:=0;
 y[1]:=1.0-ecc;
 y[2]:=0;
 y[3]:=0;
 y[4]:=alfa*sqrt((1.0+ecc)/(1.0-ecc));
 relerr:=1e-9;
 abserr:=0.0;
 tfinal:=12.0;
 tprint:=0.5;
 iflag:=1;
 tout:=t;
10: RKF45(FexRunge,n, y, h,t,tout,relerr,abserr,
       iflag,nfe,kop,init,jflag,kflag,ypp,f1,f2,f3,f4,f5,savre, savae);
  writeln(iflag,t,y[1],y[2]);
  case iflag of
 1,8: begin writeln('improper call');goto stop end;
 2: begin tout:=t+tprint;
     if t > tfinal then goto stop;end;
 3: writeln(relerr,abserr);
 4: writeln('many steps');
 5: begin abserr:=1e-9;writeln(relerr,abserr) end;
 6: begin relerr:=10.*relerr;iflag:=2; writeln(relerr,abserr) end;
 7: begin iflag:=2; writeln('Much output ');end;
  end;
goto 10;
stop:
end. { program }