
Uses Crt, RungeU,graph;
const n=2;
      pi = 3.1415926;
      ndemph = 1.0;
      freq = 3.0; { Hz }
      time = false;
var
      i                 : integer;
      prim              : boolean;
      x,eps,eta,xfin,h,T  : realType;
      y,yfin            : array[1..n] of realType;
    grDriver : Integer;
    grMode   : Integer;
    ErrCode  : Integer;

procedure Fex(T : RealType; var YI; n : integer; var YPI);
var
    y  :  arrayType absolute yI;
    YP :  arrayType absolute yPI;
begin
    yp[1]:=y[2];
    yp[2]:=-2*ndemph*y[2]-sqr(2*pi*freq)*y[1];
end;

begin
    ClrScr;
    eps:=1e-9; eta:=1e-9;
    T:=1/freq;
    x:=0; xfin:=0; prim:=true; h:=T/1000;
    y[1]:=1; y[2]:=0;
    grDriver := Detect;
    InitGraph(grDriver,grMode,'c:\tp5');
    ErrCode := GraphResult;
    if ErrCode = grOk then
      begin
        { Do graphics }
         while xfin < 10*T do
           begin
             xfin:=x+h;
             Runge(Fex,x,y,n,eps,eta,xfin,prim,yfin);
             prim:=false;
             if time then
               putPixel(round(xfin/(10*T)*700),round((yfin[1]+1)*170),White)
             else
               putPixel(round((yfin[1]+1.5)*170),round((yfin[2]+20)*10), White);
             for i:=1 to n do y[i]:=yfin[i];
             x:=x+h;
           end;
        ReadLn;
        CloseGraph;
      end
    else
      WriteLn('Graphics error:',
              GraphErrorMsg(ErrCode));
  end.

{ -----------------------------  17.04.91 --------------------------------- }


{$N+,E+,F+}

  UNIT RungeU;
                                INTERFACE

  type   RealType = double;

  const  ArraySize = (2*MaxInt) div SizeOf(RealType);

  type
         ArrayType =array[1..ArraySize] of realType;
         ProcType = procedure ( T : RealType; var YI; n : integer; var YPI);

   var ss : integer;
       hs : RealType;

 procedure Runge(Fex : ProcType; x: RealType; var y5; n :integer;
                 var eps,eta,xfin : RealType; var prim : boolean;
                 var yfin1);
{          Runge(FexRunge,x,y,n,eps,eta,xfin,prim,yfin); }

                         Implementation


   { Subroutine: Runge-Kutt  4 number from the "Communication of the ACM"
                 algorithm 9 b   , adupted by Kvashnin S.E.     }

   function comp(a,b,c: RealType) : RealType;

     var ae,be,ce,i,aae   : longint;
         co,com           : RealType;

     function expon(x: RealType): longint;

      begin
        if x=0.0 then expon:=-324
           else expon:= round(0.4342944819*ln(abs(x))+1);
      end; { Expon }

      Begin
        ae:=expon(a); be:=expon(b); ce:=expon(c);
        if ae < be then ae:=be;
        if ae < ce then ae:=ce;
        co:=1;
        aae:=abs(ae);
        if ae<>0 then
           begin
              for i:=1 to aae do  co:=co*10;
              if ae<0 then co:=1.0/co;
           end;
        comp:=abs(a-b)/co;
      End; { comp }

 procedure Runge(Fex : ProcType; x: RealType; var y5; n :integer;
                 var eps,eta,xfin : RealType; var prim : boolean;
                 var yfin1);

  label 1,11,12,13,100;

  const nn=100; { max order of diff.equations }

  var
      x1,x2,x3,h                   : RealType;
      k,j                          : integer;
      out                          : boolean;
      z,y1,y2,y3                   : Array[1..nn] of realType;
      y                            : arrayType absolute y5;
      yfin                         : arrayType absolute yfin1;

 procedure rk1step(Fex : ProcType; x : RealType; var y1; h : RealType;
                        var xh : RealType; var yh1);
 var
    j,k       : integer;
    a         : array[1..5] of RealType;
    w         : array[1..nn] of RealType;
    y : ArrayType absolute y1;
    yh: ArrayType absolute yh1;

 Begin
    a[1]:=0.5*h;
    a[2]:=0.5*h;
    a[5]:=0.5*h;
    a[3]:=h; a[4]:=h; xh:=x;
    for k:=1 to n do
      begin yh[k]:=y[k];w[k]:=y[k]; end;
    for j:=1 to 4 do
      begin Fex(xh,w,n,z);
        xh:=x+a[j];
        for k:=1 to n do
          begin yh[k]:=yh[k]+a[j+1]*z[k]/3;
            w[k]:=y[k]+a[j]*z[k];
          end; {k}
      end; {j}
 End; {rk1step}
 Begin
 1: if prim then
       begin
         h:=xfin-x; ss:=0;
       end
    else h:=hs;
    out:=false;
11: if((x+2.01*h-xfin)*h>0.0) then
      begin hs:=h; out:=true; h:=(xfin-x)/2.0; end;
    rk1step(Fex,x,y,2*h,x1,y1);
12: rk1step(Fex,x,y,h,x2,y2);
    rk1step(Fex,x2,y2,h,x3,y3);
    for k:=1 to n do
      if comp(y1[k],y3[k],eta) > eps then goto 13;
    x:=x3;
    if out then goto 100;
    for k:=1 to n do y[k]:=y3[k];
    if ss=5 then begin ss:=0; h:=2*h end;
    ss:=ss+1; goto 11;
13: h:=0.5*h; out:=false; x1:=x2;
    for k:=1 to n do y1[k]:=y2[k];
    goto 12;
100:for k:=1 to n do yfin[k]:=y3[k];
End; {Runge}
{****************************************************************************}
end.